diff --git a/src/aboutDialog.cpp b/src/aboutDialog.cpp
index 4b5bb52..a57b665 100644
--- a/src/aboutDialog.cpp
+++ b/src/aboutDialog.cpp
@@ -74,7 +74,7 @@ NAboutDialog::NAboutDialog(QWidget *parent) : QDialog(parent)
     QSvgWidget svgWidget(":icon.svg");
     svgWidget.setStyleSheet("background: transparent");
     svgWidget.resize(96, 96);
-    iconLabel->setPixmap(svgWidget.grab());
+    iconLabel->setPixmap(QPixmap::grabWidget(&svgWidget));
 
     QHBoxLayout *iconLayout = new QHBoxLayout;
     iconLayout->addStretch();
diff --git a/src/action.cpp b/src/action.cpp
index 8c52d4d..ccb08d7 100644
--- a/src/action.cpp
+++ b/src/action.cpp
@@ -23,7 +23,7 @@ bool NAction::isEnabled() const
 
 void NAction::setEnabled(bool enable)
 {
-    for (QxtGlobalShortcut *shortcut : m_globalShortcuts) {
+    foreach (QxtGlobalShortcut *shortcut, m_globalShortcuts) {
         shortcut->setEnabled(enable);
     }
     QAction::setEnabled(enable);
@@ -47,7 +47,7 @@ QList<QKeySequence> NAction::sequences() const
 QStringList NAction::shortcuts() const
 {
     QStringList shortcuts;
-    for (const QKeySequence &seq : sequences()) {
+    foreach (const QKeySequence &seq, sequences()) {
         shortcuts << seq.toString();
     }
     return shortcuts;
@@ -61,7 +61,7 @@ void NAction::setSequences(const QList<QKeySequence> &sequences)
 void NAction::setShortcuts(const QStringList &shortcuts)
 {
     QList<QKeySequence> sequences;
-    for (const QString &str : shortcuts) {
+    foreach (const QString &str, shortcuts) {
         sequences << QKeySequence(str);
     }
     setSequences(sequences);
@@ -70,7 +70,7 @@ void NAction::setShortcuts(const QStringList &shortcuts)
 QList<QKeySequence> NAction::globalSequences() const
 {
     QList<QKeySequence> sequences;
-    for (QxtGlobalShortcut *shortcut : m_globalShortcuts) {
+    foreach (QxtGlobalShortcut *shortcut, m_globalShortcuts) {
         sequences << shortcut->shortcut();
     }
     return sequences;
@@ -79,7 +79,7 @@ QList<QKeySequence> NAction::globalSequences() const
 QStringList NAction::globalShortcuts() const
 {
     QStringList shortcuts;
-    for (const QKeySequence &seq : globalSequences()) {
+    foreach (const QKeySequence &seq, globalSequences()) {
         shortcuts << seq.toString();
     }
     return shortcuts;
@@ -87,14 +87,14 @@ QStringList NAction::globalShortcuts() const
 
 void NAction::setGlobalSequences(const QList<QKeySequence> &sequences)
 {
-    for (QxtGlobalShortcut *shortcut : m_globalShortcuts) {
+    foreach (QxtGlobalShortcut *shortcut, m_globalShortcuts) {
         delete shortcut;
     }
     m_globalShortcuts.clear();
 
-    for (const QKeySequence &seq : sequences) {
+    foreach (const QKeySequence &seq, sequences) {
         QxtGlobalShortcut *s = new QxtGlobalShortcut(this);
-        connect(s, &QxtGlobalShortcut::activated, this, &QAction::trigger);
+        connect(s, SIGNAL(activated()), this, SIGNAL(triggered()));
         s->setShortcut(seq);
         m_globalShortcuts << s;
     }
@@ -103,8 +103,14 @@ void NAction::setGlobalSequences(const QList<QKeySequence> &sequences)
 void NAction::setGlobalShortcuts(const QStringList &shortcuts)
 {
     QList<QKeySequence> sequences;
-    for (const QString &str : shortcuts) {
-        sequences << QKeySequence(str);
+    foreach (const QString &str, shortcuts) {
+        // Qt4: Don't create shortcuts for empty or invalid strings
+        if (!str.isEmpty() && str != "@Invalid()") {
+            QKeySequence seq(str);
+            if (!seq.isEmpty()) {
+                sequences << seq;
+            }
+        }
     }
     setGlobalSequences(sequences);
 }
diff --git a/src/action.h b/src/action.h
index 700a138..f2534ef 100644
--- a/src/action.h
+++ b/src/action.h
@@ -25,7 +25,9 @@ class NAction : public QAction
     Q_OBJECT
 
 public:
-    using QAction::QAction;
+    NAction(QObject *parent = 0) : QAction(parent), m_isCustomizable(false) {}
+    NAction(const QString &text, QObject *parent = 0) : QAction(text, parent), m_isCustomizable(false) {}
+    NAction(const QIcon &icon, const QString &text, QObject *parent = 0) : QAction(icon, text, parent), m_isCustomizable(false) {}
 
     bool isEnabled() const;
     void setEnabled(bool enable);
@@ -44,7 +46,7 @@ public:
     void setGlobalShortcuts(const QStringList &shortcuts);
 
 private:
-    bool m_isCustomizable = false;
+    bool m_isCustomizable;
     QList<QxtGlobalShortcut *> m_globalShortcuts;
 };
 
